VERSION 5.00
Begin VB.Form Form1 
   BackColor       =   &H00000000&
   Caption         =   ""
   ClientHeight    =   4290
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4680
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   24
      Charset         =   204
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   4290
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Declare Function GetTickCount Lib "kernel32" () As Long
Const N As Long = 100, M As Long = 100, NM As Long = N * M - 1, Moves As Long = 65536

Dim Index(0 To N - 1, 0 To M - 1) As Long
Dim Color(0 To N * M) As Long
Dim DX(0 To 4) As Long, DY(0 To 4) As Long
Dim Cursors(0 To 5) As IPictureDisp
Dim lastX As Long, lastY As Long, ItemsLeft As Long
Dim t As Long

Private Sub Form_Click()
   
   If ItemsLeft = 0 Then
      ItemsLeft = -1
   ElseIf ItemsLeft = -1 Then
      Dim Q As Long, X As Long, Y As Long, NewX As Long, NewY, D As Long, NoD As Long
    
      X = N - 1
      Y = M - 1
      D = 3
      Randomize Timer()
      Dim count As Long, count2 As Long, count3 As Long
      Dim moveDir  As Long, moveDirReverse As Long, lastMoveDir As Long
      For Q = 1 To Moves
        NoD = 4 - D
        D = Int(Rnd() * 3)
        If D >= NoD Then D = D + 1
        NewX = X + DX(D)
        NewY = Y + DY(D)
        If NewX >= 0 And NewX < N And NewY >= 0 And NewY < M Then
          If Index(X, Y) = Index(NewX, NewY) Then
             count2 = count2 + 1
          Else
             If Y = NewY Then
                If X > NewX Then moveDir = 1 Else moveDir = 2 'left/right
             ElseIf X = NewY Then
                If Y > NewY Then moveDir = 3 Else moveDir = 4 'left/right
             End If
             If moveDir < 3 Then
                moveDirReverse = IIf(moveDir = 1, 2, 1)
             Else
                moveDirReverse = IIf(moveDir = 3, 4, 3)
             End If
             If lastMoveDir = moveDirReverse Then
                count3 = count3 + 1
             End If
             lastMoveDir = moveDir
          End If
          Index(X, Y) = Index(NewX, NewY)
          X = NewX
          Y = NewY
        Else: count = count + 1
        End If
      Next Q
      Debug.Print " ", "", ""
      Debug.Print count, count2, count3
      Index(X, Y) = NM
    
      For X = 0 To N - 1
         For Y = 0 To M - 1
            If X * M + Y <> Index(X, Y) Then ItemsLeft = ItemsLeft + 1
         Next Y
      Next X
    
      Form_Paint
   End If
End Sub

Private Sub Form_Load()
   t = GetTickCount
   Dim Q As Long, W As Long
  
   For Q = 0 To N - 1
      For W = 0 To M - 1
         Index(Q, W) = Q * M + W
         Color(Index(Q, W)) = RGB(128 + (N - Q) / N * 128, 128 + (M - W) / M * 128, ((N - Q) * (M - W) / (N + M)) * 256 Mod 256)
       Next W
   Next Q
  
   DX(0) = -1
   DX(1) = 0
   DX(2) = 0
   DX(3) = 1
  
   DY(0) = 0
   DY(1) = -1
   DY(2) = 1
   DY(3) = 0
  
   Set Cursors(0) = LoadPicture(App.Path & "\Up.cur")
   Set Cursors(1) = LoadPicture(App.Path & "\Left.cur")
   Set Cursors(2) = LoadPicture(App.Path & "\Right.cur")
   Set Cursors(3) = LoadPicture(App.Path & "\Down.cur")
   Set Cursors(4) = LoadPicture(App.Path & "\None.cur")
   
   Me.MousePointer = vbCustom
   ItemsLeft = -1
   Form_Click
   Debug.Print "form_load = " & GetTickCount - t
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
   lastX = Int(Y)
   lastY = Int(X)
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
   If ItemsLeft > 0 Then
     If Button = 0 Then
        Dim CurX As Long, CurY As Long, NewX As Long, NewY As Long, Q As Long
      
        CurX = Int(Y)
        CurY = Int(X)
      
        For Q = 0 To 3
           NewX = CurX + DX(Q)
           NewY = CurY + DY(Q)
           If NewX >= 0 And NewX < N And NewY >= 0 And NewY < M Then If Index(NewX, NewY) = NM Then Exit For
        Next Q
       
        Me.MouseIcon = Cursors(Q)
      End If
   Else
      Me.MouseIcon = Cursors(4)
   End If
End Sub

Private Sub Form_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
   If ItemsLeft > 0 Then
      Dim CurX As Long, CurY As Long, Q As Long
    
      CurX = Int(Y)
      CurY = Int(X)
    
      If CurX = lastX And CurY = lastY Then
         For Q = 0 To 3
            CurX = lastX + DX(Q)
            CurY = lastY + DY(Q)
            If CurX >= 0 And CurX < N And CurY >= 0 And CurY < M Then If Index(CurX, CurY) = NM Then Exit For
         Next Q
       End If
    
      If Abs(CurX - lastX) + Abs(CurY - lastY) = 1 And CurX >= 0 And CurX < N And CurY >= 0 And CurY < M Then
         If Index(CurX, CurY) = NM Then
            If Index(lastX, lastY) = lastX * M + lastY Then ItemsLeft = ItemsLeft + 1
            Index(CurX, CurY) = Index(lastX, lastY)
            If Index(CurX, CurY) = CurX * M + CurY Then ItemsLeft = ItemsLeft - 1
            Index(lastX, lastY) = NM
            'Form_Paint
         End If
      End If
   End If
End Sub

Private Sub Form_Paint()
   Dim Text As String
    
   If ItemsLeft > 0 Then
      Dim Q As Long, W As Long
      For Q = 0 To N - 1
         For W = 0 To M - 1
            Me.Line (W, Q)-(W + 1, Q + 1), Color(Index(Q, W)), BF
            If Index(Q, W) <> NM Then
               Text = Index(Q, W) + 1
               Me.CurrentX = W + (1 - Me.TextWidth(Text)) / 2
               Me.CurrentY = Q + (1 - Me.TextHeight(Text)) / 2
               Me.Print Text
             End If
         Next W
       Next Q
   Else
      Text = "WIN"
      Me.Line (0, 0)-(Me.ScaleWidth, Me.ScaleHeight), vbWhite, BF
      Me.CurrentX = (Me.ScaleWidth - Me.TextWidth(Text)) / 2
      Me.CurrentY = (Me.ScaleHeight - Me.TextHeight(Text)) / 2
      Me.Print Text
   End If
End Sub

Private Sub Form_Resize()
   If Me.WindowState <> vbMinimized Then
      t = GetTickCount
      Me.Scale (0, 0)-(M, N)
      Me.Font.Size = IIf(Me.Height > Me.Width, Me.Width / M, Me.Height / N) / 48
      Form_Paint
      Debug.Print "form_resize = " & GetTickCount - t
      t = GetTickCount
      DoClicks 10000
      Debug.Print "clicks*10000 = " & GetTickCount - t
   End If
End Sub

Private Sub DoClicks(nRounds As Long)
   Dim X As Single, Y As Single, i As Long
   For i = 1 To nRounds
      X = GetRandom(16, ScaleWidth - 16)
      Y = GetRandom(16, ScaleHeight - 16)
      Form_MouseMove 0, 0, X, Y
      Form_MouseDown 0, 0, X, Y
      Form_MouseUp 0, 0, X, Y
   Next i
End Sub

Private Function GetRandom(X As Long, ByVal Y As Long) As Long
   GetRandom = Int((Y - X + 1) * Rnd + X)
End Function

